# Contribuer

[Looking for the english version?](CONTRIBUTING.md)

Merci de votre intérêt à contribuer à ce code !  
Toutes les contributions (même les plus petites) sont les bienvenues.
Pour garder une certaine cohérence dans le code, merci de suivre
ces quelques règles.

## 1. Commit tags

Tous les commits doivent être précédés d'emojis dans la mesure
du possible pour que la liste des commits soit plus lisible.

| Emoji      | Type de commit                   |
|:----------:|:---------------------------------|
| :book:     | Changement dans la documentation |
| :bug:      | Correction de bug                |
| :ledger:   | Déplacement de fichiers          |
| :bulb:     | Nouvelles fonctionnalités        |
| :lipstick: | Correction du style de code      |

## 2. Branches

Merci d'utiliser un nom de branche différent de
`master` pour vos pull requests, pour que l'historique
soit plus lisible.

Par exemple, pour améliorer la documentation, vous
pourriez choisir le nom `improve-docs`.

## 3. Conventions de style

Le code Javascript peut être écrit suivant
[beaucoup](https://google-styleguide.googlecode.com/svn/trunk/javascriptguide.xml)
[de](https://github.com/airbnb/javascript)
[styles](https://github.com/felixge/node-style-guide)
[différents](https://contribute.jquery.org/style-guide/js/)
mais nous ne sommes pas aussi durs que ceux-ci.

La règle principale est d'utiliser [ESLint](http://eslint.org/) pour
vérifier si votre code s'accorde avec nos conventions de style.
Voici quelques unes des règles :

* utiliser le paramètre de base dans `parseInt()`;
* utiliser le *one true brace style;*
* mettre un espace après les virgules, pas d'espace avant;
* mettre les virgules à la fin des lignes de préférence;
* utiliser des guillemets simples;
* écrire en camelcase;
* utiliser 4 espaces pour l'indentation.

## 4. Langue

De préférence, les noms de variables, fonctions, le texte des commentaires,
les descriptions de commits doivent être écrits en *anglais.*
